// fileread.java
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class mifwrite
{
	public static void main(String args[])
	{
		String filename;
		// parse code (text) section
		if (args.length>0) filename = args[0];
		else {
			Scanner inp = new Scanner(System.in);
			System.out.print("Enter code file name: ");
			filename = inp.nextLine();
		}
		Scanner input = file_open(filename);

		if (input==null) System.exit( 1 );
		mifwrite mif = new mifwrite();
		mif.write(input);

	}

	public void write(Scanner input)
	{
		int address, contents;
		int address_offset = 0;
		boolean first = true;
		boolean is_code = true;
		int ndepth = 64;
		int nwidth = 32;
		System.out.printf("DEPTH = %d;\n",ndepth);
		System.out.printf("WIDTH = %d;\n\n",nwidth);
		System.out.printf("ADDRESS_RADIX = HEX;\n");
		System.out.printf("DATA_RADIX = HEX;\n");
		while (input.hasNext()) {
			//System.out.println(input.nextLine());
			String token = input.next();
			if (token.equals("KERNEL")) break;
			if (token.equals("DATA")) {
				is_code = false;
				continue;
			}
			if (token.equals("STACK")) break;
			if (token.charAt(0) == '[' && token.length()<27) {
				address = (int) Long.parseLong(token.substring(3,token.length()-1),16);
				if (first) {
					address_offset = address;
					first = false;
					System.out.printf("\n\n-- address_offset %x\n\n",address_offset);
					System.out.printf("CONTENTS\n  BEGIN\n");
					System.out.printf("[0..%x]   :  0;\n",ndepth-1);
				}
				if (is_code) {
					token = input.next().substring(2);
					contents = (int) Long.parseLong(token,16);
					decode_instruction(contents);
					if (op==2 || op==3) {
						//System.out.printf("\t%08x\tjump %08x\t",contents,(jta<<2));  
						jta = ((jta<<2) - address_offset)>>2;
						//System.out.printf("new address %08x\n",jta);
						contents = (op<<26) | jta;
					}
					System.out.printf("%02x  : %08x;\n",(address-address_offset)>>2,contents);
				}
				else {
					for (int i=0; i<4; i++) {
						token = input.next().substring(2);
						contents = (int) Long.parseLong(token,16);
						System.out.printf("%02x  : %08x;\n",(address-address_offset)>>2,contents);
						address += 4;
					}
				}
				input.nextLine();
			}
			else {
				if (is_code) System.out.println("Token: " + token);
				else input.nextLine();
			}
		}
		System.out.printf("END;\n");
	
	}

	public int op, rs, rt, rd, sh, fn, imm, jta;

	public void decode_instruction(int iw)
	{
		op = (iw>>26)&0x3f;
		rs = (iw>>21)&0x1f;
		rt = (iw>>16)&0x1f;
		rd = (iw>>11)&0x1f;
		sh = (iw>>6)&0x1f;
		fn = (iw)&0x3f;
		imm = (iw)&0xffff;
		jta = (iw)&0x1ffffff;
	}

	
	public static Scanner file_open(String filename)
	{
		Scanner input;
		// create File object based on user input
		File name = new File(filename);
		if (name.exists()) {
			//System.out.printf("file name: %s\n",name.getName());
			//System.out.printf("file length: %d\n",name.length());
		}
		else {
			System.err.println("File does not exist: " + filename);
			input = null;
			//System.exit( 1 );
		}

		try {
			input = new Scanner( name );
		}
		catch (FileNotFoundException e) {
			System.err.println("Error opening file: " + filename);
			input = null;
			//System.exit( 2 );
		}
		return input;
	}
}